All of lore.kernel.org
 help / color / mirror / Atom feed
* [PATCH] btrfs: Test snapshot creation with qgroup inherit would mark qgroup inconsistent
@ 2020-04-15  6:49 Qu Wenruo
  2020-04-16 10:52 ` Filipe Manana
  0 siblings, 1 reply; 2+ messages in thread
From: Qu Wenruo @ 2020-04-15  6:49 UTC (permalink / raw)
  To: linux-btrfs, fstests

Test that a new snapshot created with qgroup inherit passed should mark
qgroup numbers inconsistent.

Such inconsistent flag is required to show that we need a qgroup rescan
to make qgroup numbers correct again.

This is unavoidable since snapshot creation with qgroup inherit acts as
snapshot creation + qgroup relationship assign.
See btrfs(5) for why such operation needs qgroup rescan.

This test failed on current kernel, the fix is submitted to the btrfs
mail list titled:
  "btrfs: qgroup: Mark qgroup inconsistent if we're inherting snapshot to a new qgroup"

Signed-off-by: Qu Wenruo <wqu@suse.com>
---
 tests/btrfs/210     | 62 +++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/210.out |  2 ++
 tests/btrfs/group   |  1 +
 3 files changed, 65 insertions(+)
 create mode 100755 tests/btrfs/210
 create mode 100644 tests/btrfs/210.out

diff --git a/tests/btrfs/210 b/tests/btrfs/210
new file mode 100755
index 00000000..daa76a87
--- /dev/null
+++ b/tests/btrfs/210
@@ -0,0 +1,62 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (C) 2020 SUSE Linux Products GmbH. All Rights Reserved.
+#
+# FS QA Test 210
+#
+# Test that a new snapshot created with qgroup inherit passed should mark
+# qgroup numbers inconsistent.
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+
+_scratch_mkfs >/dev/null
+_scratch_mount
+
+$BTRFS_UTIL_PROG subvolume create "$SCRATCH_MNT/src" > /dev/null
+_pwrite_byte 0xcd 0 16M "$SCRATCH_MNT/src/file" > /dev/null
+
+# Sync the fs to ensure data written to disk so that they can be accounted
+# by qgroup
+sync
+$BTRFS_UTIL_PROG quota enable "$SCRATCH_MNT"
+$BTRFS_UTIL_PROG quota rescan -w "$SCRATCH_MNT"
+$BTRFS_UTIL_PROG qgroup create 1/0 "$SCRATCH_MNT"
+
+# Create a snapshot with qgroup inherit
+$BTRFS_UTIL_PROG subvolume snapshot -i 1/0 "$SCRATCH_MNT/src" \
+	"$SCRATCH_MNT/snapshot" > /dev/null
+
+echo "Silence is golden"
+# If qgroup is not marked inconsistent automatically, btrfs check would
+# report error.
+
+# success, all done
+status=0
+exit
diff --git a/tests/btrfs/210.out b/tests/btrfs/210.out
new file mode 100644
index 00000000..0d9f3fa0
--- /dev/null
+++ b/tests/btrfs/210.out
@@ -0,0 +1,2 @@
+QA output created by 210
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 657ec548..e7255c46 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -212,3 +212,4 @@
 207 auto rw raid
 208 auto quick subvol
 209 auto quick log
+210 auto quick qgroup snapshot
-- 
2.23.0


^ permalink raw reply related	[flat|nested] 2+ messages in thread

* Re: [PATCH] btrfs: Test snapshot creation with qgroup inherit would mark qgroup inconsistent
  2020-04-15  6:49 [PATCH] btrfs: Test snapshot creation with qgroup inherit would mark qgroup inconsistent Qu Wenruo
@ 2020-04-16 10:52 ` Filipe Manana
  0 siblings, 0 replies; 2+ messages in thread
From: Filipe Manana @ 2020-04-16 10:52 UTC (permalink / raw)
  To: Qu Wenruo; +Cc: linux-btrfs, fstests

On Wed, Apr 15, 2020 at 11:12 PM Qu Wenruo <wqu@suse.com> wrote:
>
> Test that a new snapshot created with qgroup inherit passed should mark
> qgroup numbers inconsistent.
>
> Such inconsistent flag is required to show that we need a qgroup rescan
> to make qgroup numbers correct again.
>
> This is unavoidable since snapshot creation with qgroup inherit acts as
> snapshot creation + qgroup relationship assign.
> See btrfs(5) for why such operation needs qgroup rescan.
>
> This test failed on current kernel, the fix is submitted to the btrfs
> mail list titled:
>   "btrfs: qgroup: Mark qgroup inconsistent if we're inherting snapshot to a new qgroup"
>
> Signed-off-by: Qu Wenruo <wqu@suse.com>

Reviewed-by: Filipe Manana <fdmanana@suse.com>

Looks good, thanks.

> ---
>  tests/btrfs/210     | 62 +++++++++++++++++++++++++++++++++++++++++++++
>  tests/btrfs/210.out |  2 ++
>  tests/btrfs/group   |  1 +
>  3 files changed, 65 insertions(+)
>  create mode 100755 tests/btrfs/210
>  create mode 100644 tests/btrfs/210.out
>
> diff --git a/tests/btrfs/210 b/tests/btrfs/210
> new file mode 100755
> index 00000000..daa76a87
> --- /dev/null
> +++ b/tests/btrfs/210
> @@ -0,0 +1,62 @@
> +#! /bin/bash
> +# SPDX-License-Identifier: GPL-2.0
> +# Copyright (C) 2020 SUSE Linux Products GmbH. All Rights Reserved.
> +#
> +# FS QA Test 210
> +#
> +# Test that a new snapshot created with qgroup inherit passed should mark
> +# qgroup numbers inconsistent.
> +#
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1       # failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> +       cd /
> +       rm -f $tmp.*
> +}
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +
> +# remove previous $seqres.full before test
> +rm -f $seqres.full
> +
> +# real QA test starts here
> +
> +# Modify as appropriate.
> +_supported_fs btrfs
> +_supported_os Linux
> +_require_scratch
> +
> +_scratch_mkfs >/dev/null
> +_scratch_mount
> +
> +$BTRFS_UTIL_PROG subvolume create "$SCRATCH_MNT/src" > /dev/null
> +_pwrite_byte 0xcd 0 16M "$SCRATCH_MNT/src/file" > /dev/null
> +
> +# Sync the fs to ensure data written to disk so that they can be accounted
> +# by qgroup
> +sync
> +$BTRFS_UTIL_PROG quota enable "$SCRATCH_MNT"
> +$BTRFS_UTIL_PROG quota rescan -w "$SCRATCH_MNT"
> +$BTRFS_UTIL_PROG qgroup create 1/0 "$SCRATCH_MNT"
> +
> +# Create a snapshot with qgroup inherit
> +$BTRFS_UTIL_PROG subvolume snapshot -i 1/0 "$SCRATCH_MNT/src" \
> +       "$SCRATCH_MNT/snapshot" > /dev/null
> +
> +echo "Silence is golden"
> +# If qgroup is not marked inconsistent automatically, btrfs check would
> +# report error.
> +
> +# success, all done
> +status=0
> +exit
> diff --git a/tests/btrfs/210.out b/tests/btrfs/210.out
> new file mode 100644
> index 00000000..0d9f3fa0
> --- /dev/null
> +++ b/tests/btrfs/210.out
> @@ -0,0 +1,2 @@
> +QA output created by 210
> +Silence is golden
> diff --git a/tests/btrfs/group b/tests/btrfs/group
> index 657ec548..e7255c46 100644
> --- a/tests/btrfs/group
> +++ b/tests/btrfs/group
> @@ -212,3 +212,4 @@
>  207 auto rw raid
>  208 auto quick subvol
>  209 auto quick log
> +210 auto quick qgroup snapshot
> --
> 2.23.0
>


-- 
Filipe David Manana,

“Whether you think you can, or you think you can't — you're right.”

^ permalink raw reply	[flat|nested] 2+ messages in thread

end of thread, other threads:[~2020-04-16 11:39 UTC | newest]

Thread overview: 2+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2020-04-15  6:49 [PATCH] btrfs: Test snapshot creation with qgroup inherit would mark qgroup inconsistent Qu Wenruo
2020-04-16 10:52 ` Filipe Manana

This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.